:- use_module(list_length).

msort(L, S) :- 
	msort_depth(L, S, D), msort_sdr(L, S, D).

msort_depth(L, S, D) :- 
	list_length(L, D1, D), 
	list_length(S, D2, D), 
	msort_aux(D1, D2, D).

:- block msort_aux(-, -, ?).
msort_aux(D1, D2, D) :- 
	D1 = D2, D = D1.

:- block msort_sdr(?, ?, -). 
msort_sdr([], [], _). 
msort_sdr([X], [X], _). 
msort_sdr([X, Y | Xs], S, D) :- 
	1 =< D, 
	D1 is D - 1,
	split_sdr([X, Y | Xs], L1, L2, D), 
	msort_sdr(L1, S1, D1),
	msort_sdr(L2, S2, D1),
	merge_sdr(S1, S2, S, D).

split_sdr([], [], [], _). 
split_sdr([X | L], [X | L1], L2, D) :-
    1 =< D,
    D1 is D - 1,
    split_sdr(L, L2, L1, D1). 

merge_sdr([], Ys, Ys, _). 
merge_sdr(Xs, [], Xs, _). 
merge_sdr([X|Xs], [Y|Ys], [X|Zs], D) :- 
	1 =< D, D1 is D - 1, 
	leq(X, Y), 
	merge_sdr(Xs, [Y|Ys], Zs, D1).
merge_sdr([X|Xs], [Y|Ys], [Y|Zs], D) :- 
	1 =< D, D1 is D - 1,
	gt(X, Y),
	merge_sdr([X|Xs], Ys, Zs, D1).

:- block leq(-, ?), leq(?, -).
leq(X, Y) :- X =< Y.

:- block gt(-, ?), gt(?, -).
gt(X, Y) :- X > Y.