:- use_module(qsort_naive, [qsort/2]).

qsort(L, S) :- qsort(L, S, []).

:- block qsort(-, -, ?).
qsort([], X, X).
qsort([M | Xs], S1, S) :-
	part(Xs, M, L1, L2), 
	qsort(L1, S1, [M | S2]), 
	qsort(L2, S2, S).

:- block part(-, ?, -, ?), part(-, ?, ?, -), part(?, -, ?, ?). 
part([], _, [], []).
part([X | L], M, L1, [X | L2]) :-
	leq(M, X), 
	part(L, M, L1, L2).
part([X | L], M, [X | L1], L2) :-
	gt(M, X), 
	part(L, M, L1, L2).

:- block leq(-, ?), leq(?, -).
leq(X, Y) :- X =< Y.

:- block gt(-, ?), gt(?, -).
gt(X, Y) :- X > Y.