:- use_module(queens_naive, [main/2]).

main(N, L) :-
	findall(a, nqueens(N, _), As),
	length(As, L).

nqueens(N, Soln):-
   	length(Range, N),
   	range(Range, 1),
	perm(Range, Soln), 
	safe(Soln).

range([], _).
range([N | Ns], N) :- N1 is N + 1, range(Ns, N1).

perm([], []).
perm([X | Xs], P) :-
	select(P, X, Rs),
	perm(Xs, Rs).

select([N | Ns], N, Ns).
select([N | Ns], S, [N | Rs]) :- select(Ns, S, Rs).

safe([]).
safe([CN | CNs]) :-
	no_attack(CNs, CN, 1),	safe(CNs).

no_attack([], _, _).
no_attack([CN|CNs], First_CN, Diff) :-
	Diff =\= abs(First_CN - CN),	
   	Next_Diff is Diff + 1,
   	no_attack(CNs, First_CN, Next_Diff).
